<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<META http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>winscript.lsp</title>

<style type="text/css" media="screen">
<!--
span.arw {
	color:#666666;
	font-size: 100%;
	}
	
body, p {
	font-family: Georgia, Times New Roman, Times, serif;
	line-height: 115%;
 	}

h1, h2, h3, h4 {
	font-family: Georgia, Times New Roman, Times, serif;
   	font-size: 110%;
	}

pre {
	font-family: Andale Mono, "Bitstream Vera Sans Mono", Monaco, "Courier New";
   	font-size: 100%;
	}

tt {
	font-family: Andale Mono, "Bitstream Vera Sans Mono", Monaco, "Courier New";
	font-size: 100%;
	}
-->
</style>
</head>

<body style="margin: 20px;" text="#333333" bgcolor="#FFFFFF" 
			link="#376590" vlink="#551A8B" alink="#ffAA28">
<blockquote>
<center><h1>winscript.lsp</h1></center>
<p><a href="index.html">Module index</a></p><br/><br/><br/><h2>Module:&nbsp;winscript</h2><p>Embedded VBScript/JScript in newLISP.</p>
<b>Version: </b>0.21<br/>
<b>Author: </b>m35<br/>
<p></p>
<b>Location: </b><a href="http://www.autohotkey.net/~easycom/winscript.lsp">http://www.autohotkey.net/~easycom/winscript.lsp</a><br/>
<p></p>
 Change log:
<p></p>
 0.10 - Initial release.
<p></p>
 0.11 - Fixed memory leak when unhandled type is returned.
        Improved get-short and get-single functions.
<p></p>
 0.12 - Fixed handling of automation errors.
<p></p>
 0.20 - Large internal changes to properly handle errors. This fixes
        memory leaks and provides more comprehensive error information.
        Added <tt>(WINSCRIPT:LastResult)</tt> function to return the results of
        win32api calls.
<p></p>
 0.21 - Added missing cleanup if failure during initialization.
<p></p>
 Tested with newlisp 9.2.0.
<p></p>
 Contact me (m35) in the newLISP Fan Club forum
 <a href="http://www.alh.net/newlisp/phpbb/viewtopic.php?t=1983
">http://www.alh.net/newlisp/phpbb/viewtopic.php?t=1983</a> <p></p>
 A good list of automation error descriptions can be found in
 <a href="http://support.microsoft.com/kb/186063">KB186063</a> 
<p></p><b>example:</b><blockquote><pre> &gt; (WINSCRIPT:Initialize)
 true
 &gt; (WINSCRIPT:Exec {foo = "bar"})
 true
 &gt; (WINSCRIPT:Eval {foo})
 "bar"
 &gt; (WINSCRIPT:Uninitialize)
 true</pre></blockquote>
<p></p><b>example:</b><blockquote><pre> &gt; (WINSCRIPT:Initialize "VBScript")
 true
 &gt; (WINSCRIPT:Exec {Set oSp = CreateObject("SAPI.SpVoice")})
 true
 &gt; (WINSCRIPT:Exec {oSp.Speak "newLISP: Puts the fun back in LISP"})
 true</pre></blockquote>
<p></p><b>example:</b><blockquote><pre> ; this example requires Microsoft Excel to be installed.
 &gt; (WINSCRIPT:Initialize)
 true
 &gt; (WINSCRIPT:Exec {Set xl = CreateObject("Excel.Application")})
 true
 &gt; (WINSCRIPT:Exec {xl.Visible = True})
 true
 &gt; (WINSCRIPT:Exec {Set rng = xl.Workbooks.Add().Worksheets(1).Cells(1, 1)})
 true
 &gt; (WINSCRIPT:Exec {rng.Value = 1.2345})
 true
 &gt; (WINSCRIPT:Eval {rng.Value})
 1.2345
 &gt; (WINSCRIPT:Exec {xl.DisplayAlerts = False})
 true
 &gt; (WINSCRIPT:Exec {xl.Quit})
 true
 &gt; (WINSCRIPT:Uninitialize)
 true</pre></blockquote>
<p></p><center>- &sect; -</center><p></p>
<a name="WINSCRIPT_Initialize"></a><h3><font color=#CC0000>WINSCRIPT:Initialize</font></h3>
<b>syntax: (<font color=#CC0000>WINSCRIPT:Initialize</font> [<em>str-language</em>="VBScript"])</b><br/>
<b>parameter: </b><em>str-language</em> - either <tt>"VBScript"</tt> or <tt>"JScript"</tt><br/>
<p><b>return: </b>true on success, <tt>(throw-error)</tt> on error</p>
 Sets up the scripting environment. Must be called before any other
 functions can be used.












<p></p><center>- &sect; -</center><p></p>
<a name="WINSCRIPT_Uninitialize"></a><h3><font color=#CC0000>WINSCRIPT:Uninitialize</font></h3>
<b>syntax: (<font color=#CC0000>WINSCRIPT:Uninitialize</font>)</b><br/>
<p><b>return: </b><tt>true</tt></p>
 Releases memory for scripting environment. Does not have to be called before
 exiting the program, but it is good practice.





<p></p><center>- &sect; -</center><p></p>
<a name="WINSCRIPT_Exec"></a><h3><font color=#CC0000>WINSCRIPT:Exec</font></h3>
<b>syntax: (<font color=#CC0000>WINSCRIPT:Exec</font> <em>str-code</em>)</b><br/>
<b>parameter: </b><em>str-code</em> - code to execute<br/>
<p><b>return: </b><tt>true</tt> on success, <tt>(throw-error)</tt> on error.</p>
 Executes the scripting code.




<p></p><center>- &sect; -</center><p></p>
<a name="WINSCRIPT_Eval"></a><h3><font color=#CC0000>WINSCRIPT:Eval</font></h3>
<b>syntax: (<font color=#CC0000>WINSCRIPT:Eval</font> <em>str-code</em>)</b><br/>
<b>parameter: </b><em>str-code</em> - code to evaluate<br/>
<p><b>return: </b>resulting value on success, <tt>(throw-error)</tt> on error.</p>
 Evaluates the scripting code and returns the result. Returned types can be
 String, Byte, Integer, Long, Float, Double, Boolean (<tt>true</tt> or <tt>nil</tt>),
 or object pointer. Uninitialized variables ("Empty") are returned as an
 empty list. The remaining types (Arrays, Currency, Date, VARIANT*, and
 DECIMAL*) are not handled and will cause an error if returned. Convert these
 unhandled types to handled type (such as String) to return the value.
<p></p>
<p></p><b>example:</b><blockquote><pre> &gt; (WINSCRIPT:Initialize)
 true
 &gt; (WINSCRIPT:Eval "Now()")
 user error : Unhandled variant type
 called from user defined function WINSCRIPT:Eval
 &gt; (WINSCRIPT:Eval "CStr(Now())")
 "1/9/2008 10:07:10 PM"</pre></blockquote>
<p></p><center>- &sect; -</center><p></p>
<a name="WINSCRIPT_LastResult"></a><h3><font color=#CC0000>WINSCRIPT:LastResult</font></h3>
<b>syntax: (<font color=#CC0000>WINSCRIPT:LastResult</font>)</b><br/>
<p><b>return: </b>list of win32api function results during the last WINSCRIPT call.</p>
 The returned list of strings will hold the results of all win32api functions
 that could have failed during the last operation. If the last operation
 threw and error, the last item in the list will be the error message
 thrown.
<p></p>
<p></p><b>example:</b><blockquote><pre> &gt; (WINSCRIPT:Initialize)
 true
 &gt; (WINSCRIPT:Exec "#$@#$$^$&*&&")
 user error : Expected statement
 called from user defined function WINSCRIPT:Exec
 &gt; (WINSCRIPT:LastResult)
 ("MultiByteToWideChar ok" "SysAllocString ok" 
  "IScriptControl.ExecuteStatement -2146827264"
  "IScriptError.Description 0" "WideCharToMultiByte ok" "Expected statement")</pre></blockquote>

<p></p><center>- &part; -</center><br/>
<center><font face='Arial' size='-2' color='#444444'>
generated with <a href="http://newlisp.org">newLISP</a>&nbsp;
and <a href="http://newlisp.org/newLISPdoc.html">newLISPdoc</a>
</font></center>
</blockquote>
</body>
</html>
